this.scriptfile = "demo.js"; // useful for debugging


//--------------------------------------
//
//--------------------------------------
function prepareMovie(){
	try{


	// SHOW JS DEBUGGING CONSOLE
	if ($.jsconsole) $.jsconsole.open();

	// ADD FRAME LOOP	
	$.addFrameScript( {exitFrame:function(){_movie.go(_movie.frame);}} );
	
	// SET ALERTHOOK (ONLY FOR UNCAUGHT EXCEPTIONS)
	_player.alertHook = {
		alertHook: function(msg, text, type, stack){
		  switch (type.toString()){
		    case ("#alert"):
		    	return 0;
		    default:
			    $.log("ERROR ALERTHOOK:");
			    $.log("  msg=" + msg);
			    $.log("  text=" + text);
			    $.log("  type=" + type);
			    if (stack) $.log("  stack=" + stack);
		    return 1;
		  }
		}
	};


	// NOW PUT SOME STUFF ON THE STAGE
	var s, m;


	// SHOW A LOCAL BITMAP
	m = $.newMember("bitmap","",{filename: _movie.path + "assets"+$.PD+"test.jpg"});
	$.addSprite(m, point(400, 300));
	
	
	// LOAD AND SHOW BITMAP FROM THE WEB (ASYNCHNOUSLY)
	m = $.newMember("bitmap");
	$.addSprite(m, point(600, 400));
	(function(x){// we use a closure to 'freeze' the state of m
	$.preload("http://dasdeck.com/img/mops.jpg", function(url, err){
		x.filename = url;
	});
	})(m);


	// SHOW A TEXT
	m = $.newMember("field", "", {text:"Hello World!", border:0, font:"Arial", fontsize:36, textAlign:"center", rect:rect(0,0,800,1)});

	var textBehavior = {
		mouseDown:function(){
			this.x = {enterFrame: function(){$.log("ENTER");}};
			$.addFrameScript( this.x );
		},
		mouseUp:function(){
			$.removeFrameScript( this.x );
		},
		mouseUpOutside:function(){
			this.mouseUp();
		}
	};
	
	var txt = $.addSprite(m, point(0, 440), {ink:36}, {ID:"TEXT"});
	$.extend(txt, textBehavior);
	

	// SHOW 20 DRAGGABLE CIRCLES (USING A CUSTOM DRAG BEHAVIOR)
	var draggable = function(){
		this.mouseDown = function(){
			$.log(this.ID, this.CLASS); // SHOW ID AND CLASS
			var s = sprite(this.spriteNum);
			this.off = point(s.locH-_mouse.mouseH, s.locV-_mouse.mouseV);
			this.pressed=1;
		};
		this.mouseUp = function(){this.pressed=0};
		this.mouseUpOutside = function(){this.mouseUp()};
		this.enterFrame = function(){
			if (this.pressed){
				sprite(this.spriteNum).loc = point(_mouse.mouseH + this.off.locH, _mouse.mouseV + this.off.locV);
			}
		}
	};
	m = $.newMember("shape", "", {shapeType: symbol("oval"), filled:1, pattern:1});
	for (var i=0;i<20;i++){
		s = $.addSprite(
			m,
			point(Math.random()*750, Math.random()*550),
			{width:50, height:50, color:i<10?color(255,0,0):color(0,0,255)},
			{ID:"SHAPE"+i, CLASS:i<10?"RED":"BLUE"}
		);
		$.extend(s, new draggable);
	}

	
	var y = -20;
	
	
	// CREATE BUTTON: READ TEXT FILE
	m = $.newMember("button", "", {text:" Load Text File ", font:"Arial", fontsize:14, fontstyle:"bold", textAlign:"center"});
	s = $.addSprite(m, point(10, y+=30), {}, {
		mouseUp:function(){
			$.log( $.file_get_contents(_movie.path+"assets"+$.PD+"test.txt") );
		}
	});


	// CREATE BUTTON: SAVE TEXT FILE
	m = $.newMember("button", "", {text:" Save Text File ", font:"Arial", fontsize:14, fontstyle:"bold", textAlign:"center"});
	s = $.addSprite(m, point(10, y+=30), {}, {
		mouseUp:function(){
			$.log( $.file_put_contents(_movie.path+"test.txt", "Hello World! äöü") );
		}
	});
	
	
	// CREATE BUTTON: PARSE XML
	m = $.newMember("button", "", {text:" Load XML ", font:"Arial", fontsize:14, fontstyle:"bold", textAlign:"center"});
	$.addSprite(m, point(10, y+=30), {}, {
		mouseUp:function(){
			$.dir($.parseXML('<?xml version="1.0" encoding="utf-8"?><root><a foo="Hello World!">text</a></root>'));
		},
		rightMouseUp:function(){
			var ba = byteArray('<?xml version="1.0" encoding="utf-8"?><root><a foo="Hello World!">text</a></root>');
			$.dir($.parseXML(ba));
		}
	});


	// CREATE BUTTON: HIDE/SHOW SELECTED SPRITES
	m = $.newMember("button", "", {text:" Hide/show red circles ", font:"Arial", fontsize:14, fontstyle:"bold", textAlign:"center"});
	$.addSprite(m, point(10, y+=30), {}, {
		mouseUp:function(){
			$.toggle( $.select("CLASS", "RED") );
		}
	});


	// CREATE BUTTON: LOAD PAGE (HTTP GET REQUEST)
	m = $.newMember("button", "", {text:" HTTP Get ", font:"Arial", fontsize:14, fontstyle:"bold", textAlign:"center"});
	$.addSprite(m, point(10, y+=30), {}, {
		mouseUp:function(){
			$.get("http://www.adobe.com/");
		}
	});


	// CREATE BUTTON: CREATE A SCRIPTING ERROR)
	m = $.newMember("button", "", {text:" Create Scripting Error ", font:"Arial", fontsize:14, fontstyle:"bold", textAlign:"center"});
	$.addSprite(m, point(10, y+=30), {}, {
		mouseUp:testError
	});


	// CREATE BUTTON: TEST BREAKPOINTS)
	m = $.newMember("button", "", {text:" Test Breakpoints", font:"Arial", fontsize:14, fontstyle:"bold", textAlign:"center"});
	$.addSprite(m, point(10, y+=30), {}, {
		mouseUp:testBreakpoint
	});

	
	// CREATE BUTTON: DOWNLOAD AND UNZIP DIRECTOR HELP FILE
	m = $.newMember("button", "", {text:" HTTP Download: \n downloading Director Help", font:"Arial", fontsize:14, fontstyle:"bold", textAlign:"center"});
	$.addSprite(m, point(10, y+=30), {}, {
		mouseUp:function(){
			_player.netThrottleTicks = 1;
			var p = $.select("ID", "PROGRESSDIALOG")[0];
			$.show(p);
			$.download(
				"http://valentin.dasdeck.com/lingo/help_chm/D11.5_help_enhanced.zip",
				_movie.path+"help"+$.PD+"D11.5_help_enhanced.zip",
				// FINAL CALLBACK
				function(url,fn,err){ 
					if (err=='OK'){
						$.log("Download successful, now unpacking ZIP file...");
						$.hide(p);
						var uz = new xtra("UnzipXtra");
						var helpdir = _movie.path + "help" + $.PD;
						uz.UnzipFiles(fn, helpdir);
						uz = 0;
						$.file_delete(fn);
						$.log("Done.");
					}
				},
				// PROGRESS CALLBACK
				function(prog){
					p.showProgress(Math.round(prog*100));
					
					// SHOW PROGRESS IN CONSOLE:
					//$.log(Math.round(prog*100)+"%");
				}
			);

		}
	});


	// TESTING ASSEMBLIES (SPRITE GROUPS): CREATE A PROGRESS BAR (USED BY DOWNLOAD ABOVE)
	var progBar = createProgressBar();
	//$.show(progBar);
	
	
	}catch(e){eval($.CATCH);}
}

//--------------------------------------
//
//--------------------------------------
function startMovie(){
	try{

	// SOME FRAMEWORK TESTS (UNCOMMENT)

	// TEST ERROR HANDLING
	// var a=23;
	// var b;
	// var c = {d:[1,2,3]};
	// doesntexist();

	// TEST $.DIR
	// var o = {a:23, b:{c:66, d:'hello'}, e:[1,2,3, {g:888,h:21}]};
	// $.dir(o);

	// TEST JSON
	// var obj = $.parseJSON('{"name":"John"}');
	// $.dir(obj);
	// $.log( obj.name === "John" );

	// TEST EACH
	// $.each([1,2,3], function(i, v){$.log(i+': '+v)});
	// $.each({a:11, b:22, c:33}, function(i, v){$.log(i+': '+v)});

	// TEST INARRAY
	// var a = [2,3,4,5];
	// $.log( $.inArray(4, a) );

	// TEST MERGE
	// var a = [2,3,4,5];
	// var b = ["a", "b"];
	// $.dir( $.merge(a, b) );

	// TEST MAP
	// var a = [2,3,4,5];
	// var f = function(v,i){return v*2};
	// $.dir( $.map(a, f) );

	// TEST TRIM
	// var s = "  aaa\t\t";
	// s = $.trim(s);
	// $.log('|'+s+'|');

	// TEST MAKELIST
	// var o = [1,2,3, {g:888,h:21}];
	// var res = $.makeList(o);
	// $.dir(res);

	// TEST MAKEPROPLIST
	// var o = {a:23, b:{c:66, d:'hello'}, e:[1,2,3, {g:888,h:21}]};
	// var res = $.makePropList(o);
	// $.dir(res);

	// TEST TIMEOUT/INTERVAL
	// $.doTimeout(1000, function(a,b,c){$.log("HELLO "+c);}, [1,2,3]);
	// $.doInterval(1000, function(a,b,c){$.log("HELLO "+c);}, [1,2,3]);

	// TEST GREP
	// var arr = [ 1, 9, 3, 8, 6, 2, 5, 9, 4, 7, 3, 6, 9, 1 ];
	// arr = $.grep(arr, function(n, i){
	//   return (n%2==0 && i > 2);
	// });
	// $.dir(arr);

	// TEST: SELECT
	// var a = $.select("CLASS", "RED");
	// $.dir(a);
	// var s = $.select("ID", "SHAPE7");
	// $.dir(s);
	
	
	}catch(e){eval($.CATCH);}
}

//--------------------------------------
// error details printed to console, script execution continues
//--------------------------------------
function testError(){
	try{


		// SOME LOCAL VARS
		var a, b="HELLO", c={d:23,e:[1,2,3]};

		// RAISES AN ERROR
		functionDoesntExist();


	}catch(e){eval($.CATCH);}
}

//--------------------------------------
// like testError(), but pauses script execution on error (via alert dialog)
//--------------------------------------
function testErrorBreak(){
	try{


		// SOME LOCAL VARS
		var a, b="HELLO", c={d:23,e:[1,2,3]};

		// RAISES AN ERROR
		functionDoesntExist();


	}catch(e){eval($.CATCHBREAK);}
}

//--------------------------------------
//
//--------------------------------------
function testBreakpoint(){

	// SOME LOCAL VARS
	var a, b="HELLO", c={d:23,e:[1,2,3]};

	// ADD A BREAKPOINT
	eval($.BREAK);

	$.log("EXECUTION CONTINUES...");
	
	$.clear(); // clears JS console
	
	// ADD ANOTHER BREAKPOINT, ALSO PRINTING THE CONTENTS OF THE _player AND _movie OBJECTS
	eval("var more=[_player,_movie];"+$.BREAK);
	
	$.log("EXECUTION CONTINUES...");

}

//--------------------------------------
// CREATES A SIMPLE PROGRESBAR COMPONENT (=SPRITE ASSEMBLY)
// API: progBar.showProgress(percentage)
//--------------------------------------
function createProgressBar(){
	try{
		
	// DRAG-BEHAVIOR
	var draggable = {
		mouseDown: function(){
			var s = sprite(this.spriteNum);
			this.off = point(s.locH-_mouse.mouseH, s.locV-_mouse.mouseV);
			this.pressed=1;
		},
		mouseUp: function(){
			this.pressed=0;
		},
		mouseUpOutside: function(){
			this.mouseUp();
		},
		enterFrame: function(){
			if (this.pressed){
				$.moveto(sprite(this.spriteNum), point(_mouse.mouseH+this.off.locH, _mouse.mouseV+this.off.locV));
			}
		}
	};
	
	// PASS-MOUSEEVENTS-BEHAVIOR (TO ALLOW DRAGGING VIA SUB-SPRITES)
	var passMouseEvents = {
		mouseDown: function(){
			if (this.parent&&this.parent.mouseDown) this.parent.mouseDown.call(this.parent);
		},
		mouseUp: function(){
			if (this.parent&&this.parent.mouseUp) this.parent.mouseUp.call(this.parent);
		},
		mouseUpOutside: function(){
			if (this.parent&&this.parent.mouseUpOutside) this.parent.mouseUpOutside.call(this.parent);
		}
	};
	
	// START: CREATE A SHAPE
	var filledRect = $.newMember("shape", "", {shapeType: symbol("rect"), filled:1, pattern:1});
	
	// MAIN SPRITE (BACKGROUND-RECT)
	var progDialog = $.addSprite(
		filledRect,
		point(200, 250),
		{width:400, height:100, color:color(128,128,128)},
		{hidden:true, ID:'PROGRESSDIALOG'}
	);
	$.extend(progDialog, draggable);

	// ACTUAL BAR
	var progBar = $.addChild(
		progDialog,
		filledRect,
		point(20, 20),
		{width:60, height:60, color:color(128,0,0)},
		{ID:'PROGRESSBAR'}
	);
	$.extend(progBar, passMouseEvents);
		
	// TEXT SHOWING PERCENTAGE
	var percentageField = $.newMember("field", "", {text:"0%", font:"Arial", fontsize:36, textAlign:"center", rect:rect(0,0,100,1),color:color(255,255,255)});
	var progText = $.addChild(
		progDialog,
		percentageField,
		point(150, 30),
		{width:100, color:color(255,255,255), ink:36},
		{ID:'PROGRESSPERCENT'}
	);
	$.extend(progText, passMouseEvents);
	
	progDialog.showProgress = function(pct){
		progBar.width = pct * 3.6;
		progText.member.text = pct + "%";
	}
	progDialog.showProgress(0);
	return progDialog;
	
	}catch(e){eval($.CATCH);}
}

