this.scriptfile = "framework_file.js"; // useful for debugging

// reads whole file, returns string
$.file_get_contents = function(fn){
  var fp = new xtra("fileIO");
  if (!fp.ilk(symbol('instance'))) return false;
  fp.openFile(fn, 1);
  if (fp.status()) return false;
  var ret = fp.readFile();
  fp.closeFile();
  fp = 0;
  return ret;
};

// save string as file
$.file_put_contents = function(fn, str){
  var fp = new xtra("fileIO");
  if (!fp.ilk(symbol('instance'))) return false;
  fp.openFile(fn, 1);
  var err = fp.status();
  if (!err) _movie.call(symbol("delete"), fp);
  else if (err && (err!=-37)) return false;
  fp.createFile(fn);
  if (fp.status()) return false;
  fp.openFile(fn, 2);
  if (fp.status()) return false;
  fp.writeString(str);
  fp.closeFile();
  fp=0;
  return true;
};

// return file as ByteArray
$.file_get_bytes = function(fn){
  var fp = new xtra("fileIO");
  if (!fp.ilk(symbol('instance'))) return false;
  fp.openFile(fn, 1);
  if (fp.status()) return false;
  var ret = fp.readByteArray(fp.getLength());
  fp.closeFile();
  fp = 0;
  return ret;
};

// save ByteArray to file
$.file_put_bytes = function(fn, ba){
  var fp = new xtra("fileIO");
  if (!fp.ilk(symbol('instance'))) return false;
  fp.openFile(fn, 1);
  var err = fp.status();
  if (!err) _movie.call(symbol("delete"), fp);
  else if (err && (err!=-37)) return false;
  fp.createFile(fn);
  if (fp.status()) return false;
  fp.openFile(fn, 2);
  if (fp.status()) return false;
  fp.writeByteArray(ba);
  fp.closeFile();
  fp=0;
  return true;
};

// display open file dialog
$.display_open = function(title, filterMask, defaultFileName){
  var fp = new xtra("fileIO");
  if (!fp.ilk(symbol('instance'))) return false;
  fp.setFilterMask(filterMask);
  var fn=fio.displayOpen();
  fp=0;
  return fn.toString();
}

// display save file dialog
$.display_save = function(title, filterMask, defaultFileName){
  var fp = new xtra("fileIO");
  if (!fp.ilk(symbol('instance'))) return false;
  fp.setFilterMask(filterMask);
  var fn=fio.displaySave(title, defaultFileName);
  fp=0;
  return fn.toString();
}

// returns file size
$.file_size = function(tFile){
  var fp = new xtra("fileIO");
  if (!fp.ilk(symbol('instance'))) return false;
  fp.openFile(tFile, 1);
  if (fp.status()) return false;
  var len = fp.getLength();
  fp.closeFile();
  fp = 0;
  return len;
}

// deletes file
$.file_delete = function(tFile){
  var fp = new xtra("fileIO");
  if (!fp.ilk(symbol('instance'))) return false;
  fp.openFile(tFile, 0);
  var err = fp.status();
  if (!err) err = _movie.call(symbol("delete"), fp);
  fp = 0;
  return err;
}

// check if file exists
$.file_exists = function(tFile){
  var fp = new xtra("fileIO");
  if (!fp.ilk(symbol('instance'))) return false;
  fp.openFile(tFile, 1);
  var stat = fp.status();
  fp.closeFile();
  fp = 0;
  return (stat!=-37);
}
